javax.servlet

## Interface ServletResponse

- All Known Subinterfaces:
    HttpServletResponse
  All Known Implementing Classes:
    HttpServletResponseWrapper, ServletResponseWrapper

      public interface ServletResponse

  Defines an object to assist a servlet in sending a response to the client. The servlet container creates a `ServletResponse` object and passes it as an argument to the servlet's `service` method.

  To send binary data in a MIME body response, use the `ServletOutputStream` returned by `getOutputStream()`. To send character data, use the `PrintWriter` object returned by `getWriter()`. To mix binary and text data, for example, to create a multipart response, use a `ServletOutputStream` and manage the character sections manually.

  The charset for the MIME body response can be specified explicitly using the `setCharacterEncoding(java.lang.String)` and `setContentType(java.lang.String)` methods, or implicitly using the `setLocale(java.util.Locale)` method. Explicit specifications take precedence over implicit specifications. If no charset is specified, ISO-8859-1 will be used. The `setCharacterEncoding`, `setContentType`, or `setLocale` method must be called before `getWriter` and before committing the response for the character encoding to be used.

  See the Internet RFCs such as RFC 2045 for more information on MIME. Protocols such as SMTP and HTTP define profiles of MIME, and those standards are still evolving.

  Author:
    Various
  See Also:
    `ServletOutputStream`

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `flushBuffer()` Forces any content in the buffer to be written to the client.
    `int` | `getBufferSize()` Returns the actual buffer size used for the response.
    `String` | `getCharacterEncoding()` Returns the name of the character encoding (MIME charset) used for the body sent in this response.
    `String` | `getContentType()` Returns the content type used for the MIME body sent in this response.
    `Locale` | `getLocale()` Returns the locale specified for this response using the `setLocale(java.util.Locale)` method.
    `ServletOutputStream` | `getOutputStream()` Returns a `ServletOutputStream` suitable for writing binary data in the response.
    `PrintWriter` | `getWriter()` Returns a `PrintWriter` object that can send character text to the client.
    `boolean` | `isCommitted()` Returns a boolean indicating if the response has been committed.
    `void` | `reset()` Clears any data that exists in the buffer as well as the status code, headers.
    `void` | `resetBuffer()` Clears the content of the underlying buffer in the response without clearing headers or status code.
    `void` | `setBufferSize(int size)` Sets the preferred buffer size for the body of the response.
    `void` | `setCharacterEncoding(String charset)` Sets the character encoding (MIME charset) of the response being sent to the client, for example, to UTF-8.
    `void` | `setContentLength(int len)` Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
    `void` | `setContentLengthLong(long len)` Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
    `void` | `setContentType(String type)` Sets the content type of the response being sent to the client, if the response has not been committed yet.
    `void` | `setLocale(Locale loc)` Sets the locale of the response, if the response has not been committed yet.

- - ### Method Detail

    - #### getCharacterEncoding

          String getCharacterEncoding()

      Returns the name of the character encoding (MIME charset) used for the body sent in this response. The character encoding may have been specified explicitly using the `setCharacterEncoding(java.lang.String)` or `setContentType(java.lang.String)` methods, or implicitly using the `setLocale(java.util.Locale)` method. Explicit specifications take precedence over implicit specifications. Calls made to these methods after `getWriter` has been called or after the response has been committed have no effect on the character encoding. If no character encoding has been specified, `ISO-8859-1` is returned.

      See RFC 2047 (http://www.ietf.org/rfc/rfc2047.txt) for more information about character encoding and MIME.

      Returns:
        a `String` specifying the name of the character encoding, for example, `UTF-8`

    - #### getContentType

          String getContentType()

      Returns the content type used for the MIME body sent in this response. The content type proper must have been specified using `setContentType(java.lang.String)` before the response is committed. If no content type has been specified, this method returns null. If a content type has been specified, and a character encoding has been explicitly or implicitly specified as described in `getCharacterEncoding()` or `getWriter()` has been called, the charset parameter is included in the string returned. If no character encoding has been specified, the charset parameter is omitted.
      Returns:
        a `String` specifying the content type, for example, `text/html; charset=UTF-8`, or null
      Since:
        Servlet 2.4

    - #### getOutputStream

          ServletOutputStream getOutputStream()
                                              throws IOException

      Returns a `ServletOutputStream` suitable for writing binary data in the response. The servlet container does not encode the binary data.

      Calling flush() on the ServletOutputStream commits the response. Either this method or `getWriter()` may be called to write the body, not both, except when `reset()` has been called.

      Returns:
        a `ServletOutputStream` for writing binary data
      Throws:
        `IllegalStateException` - if the `getWriter` method has been called on this response
        `IOException` - if an input or output exception occurred
      See Also:
        `getWriter()`, `reset()`

    - #### getWriter

          PrintWriter getWriter()
                                throws IOException

      Returns a `PrintWriter` object that can send character text to the client. The `PrintWriter` uses the character encoding returned by `getCharacterEncoding()`. If the response's character encoding has not been specified as described in `getCharacterEncoding` (i.e., the method just returns the default value `ISO-8859-1`), `getWriter` updates it to `ISO-8859-1`.

      Calling flush() on the `PrintWriter` commits the response.

      Either this method or `getOutputStream()` may be called to write the body, not both, except when `reset()` has been called.

      Returns:
        a `PrintWriter` object that can return character data to the client
      Throws:
        `UnsupportedEncodingException` - if the character encoding returned by `getCharacterEncoding` cannot be used
        `IllegalStateException` - if the `getOutputStream` method has already been called for this response object
        `IOException` - if an input or output exception occurred
      See Also:
        `getOutputStream()`, `setCharacterEncoding(java.lang.String)`, `reset()`

    - #### setCharacterEncoding

          void setCharacterEncoding(String charset)

      Sets the character encoding (MIME charset) of the response being sent to the client, for example, to UTF-8. If the character encoding has already been set by `setContentType(java.lang.String)` or `setLocale(java.util.Locale)`, this method overrides it. Calling `setContentType(java.lang.String)` with the `String` of `text/html` and calling this method with the `String` of `UTF-8` is equivalent with calling `setContentType` with the `String` of `text/html; charset=UTF-8`.

      This method can be called repeatedly to change the character encoding. This method has no effect if it is called after `getWriter` has been called or after the response has been committed.

      Containers must communicate the character encoding used for the servlet response's writer to the client if the protocol provides a way for doing so. In the case of HTTP, the character encoding is communicated as part of the `Content-Type` header for text media types. Note that the character encoding cannot be communicated via HTTP headers if the servlet does not specify a content type; however, it is still used to encode text written via the servlet response's writer.

      Parameters:
        `charset` - a String specifying only the character set defined by IANA Character Sets (http://www.iana.org/assignments/character-sets)
      Since:
        Servlet 2.4
      See Also:
        `setContentType(java.lang.String)`, `setLocale(java.util.Locale)`

    - #### setContentLength

          void setContentLength(int len)

      Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
      Parameters:
        `len` - an integer specifying the length of the content being returned to the client; sets the Content-Length header

    - #### setContentLengthLong

          void setContentLengthLong(long len)

      Sets the length of the content body in the response In HTTP servlets, this method sets the HTTP Content-Length header.
      Parameters:
        `len` - a long specifying the length of the content being returned to the client; sets the Content-Length header
      Since:
        Servlet 3.1

    - #### setContentType

          void setContentType(String type)

      Sets the content type of the response being sent to the client, if the response has not been committed yet. The given content type may include a character encoding specification, for example, `text/html;charset=UTF-8`. The response's character encoding is only set from the given content type if this method is called before `getWriter` is called.

      This method may be called repeatedly to change content type and character encoding. This method has no effect if called after the response has been committed. It does not set the response's character encoding if it is called after `getWriter` has been called or after the response has been committed.

      Containers must communicate the content type and the character encoding used for the servlet response's writer to the client if the protocol provides a way for doing so. In the case of HTTP, the `Content-Type` header is used.

      Parameters:
        `type` - a `String` specifying the MIME type of the content
      See Also:
        `setLocale(java.util.Locale)`, `setCharacterEncoding(java.lang.String)`, `getOutputStream()`, `getWriter()`

    - #### setBufferSize

          void setBufferSize(int size)

      Sets the preferred buffer size for the body of the response. The servlet container will use a buffer at least as large as the size requested. The actual buffer size used can be found using `getBufferSize`.

      A larger buffer allows more content to be written before anything is actually sent, thus providing the servlet with more time to set appropriate status codes and headers. A smaller buffer decreases server memory load and allows the client to start receiving data more quickly.

      This method must be called before any response body content is written; if content has been written or the response object has been committed, this method throws an `IllegalStateException`.

      Parameters:
        `size` - the preferred buffer size
      Throws:
        `IllegalStateException` - if this method is called after content has been written
      See Also:
        `getBufferSize()`, `flushBuffer()`, `isCommitted()`, `reset()`

    - #### getBufferSize

          int getBufferSize()

      Returns the actual buffer size used for the response. If no buffering is used, this method returns 0.
      Returns:
        the actual buffer size used
      See Also:
        `setBufferSize(int)`, `flushBuffer()`, `isCommitted()`, `reset()`

    - #### flushBuffer

          void flushBuffer()
                           throws IOException

      Forces any content in the buffer to be written to the client. A call to this method automatically commits the response, meaning the status code and headers will be written.
      Throws:
        `IOException`
      See Also:
        `setBufferSize(int)`, `getBufferSize()`, `isCommitted()`, `reset()`

    - #### resetBuffer

          void resetBuffer()

      Clears the content of the underlying buffer in the response without clearing headers or status code. If the response has been committed, this method throws an `IllegalStateException`.
      Since:
        Servlet 2.3
      See Also:
        `setBufferSize(int)`, `getBufferSize()`, `isCommitted()`, `reset()`

    - #### isCommitted

          boolean isCommitted()

      Returns a boolean indicating if the response has been committed. A committed response has already had its status code and headers written.
      Returns:
        a boolean indicating if the response has been committed
      See Also:
        `setBufferSize(int)`, `getBufferSize()`, `flushBuffer()`, `reset()`

    - #### reset

          void reset()

      Clears any data that exists in the buffer as well as the status code, headers. The state of calling `getWriter()` or `getOutputStream()` is also cleared. It is legal, for instance, to call `getWriter()`, `reset()` and then `getOutputStream()`. If `getWriter()` or `getOutputStream()` have been called before this method, then the corrresponding returned Writer or OutputStream will be staled and the behavior of using the stale object is undefined. If the response has been committed, this method throws an `IllegalStateException`.
      Throws:
        `IllegalStateException` - if the response has already been committed
      See Also:
        `setBufferSize(int)`, `getBufferSize()`, `flushBuffer()`, `isCommitted()`

    - #### setLocale

          void setLocale(Locale loc)

      Sets the locale of the response, if the response has not been committed yet. It also sets the response's character encoding appropriately for the locale, if the character encoding has not been explicitly set using `setContentType(java.lang.String)` or `setCharacterEncoding(java.lang.String)`, `getWriter` hasn't been called yet, and the response hasn't been committed yet. If the deployment descriptor contains a `locale-encoding-mapping-list` element, and that element provides a mapping for the given locale, that mapping is used. Otherwise, the mapping from locale to character encoding is container dependent.

      This method may be called repeatedly to change locale and character encoding. The method has no effect if called after the response has been committed. It does not set the response's character encoding if it is called after `setContentType(java.lang.String)` has been called with a charset specification, after `setCharacterEncoding(java.lang.String)` has been called, after `getWriter` has been called, or after the response has been committed.

      Containers must communicate the locale and the character encoding used for the servlet response's writer to the client if the protocol provides a way for doing so. In the case of HTTP, the locale is communicated via the `Content-Language` header, the character encoding as part of the `Content-Type` header for text media types. Note that the character encoding cannot be communicated via HTTP headers if the servlet does not specify a content type; however, it is still used to encode text written via the servlet response's writer.

      Parameters:
        `loc` - the locale of the response
      See Also:
        `getLocale()`, `setContentType(java.lang.String)`, `setCharacterEncoding(java.lang.String)`

    - #### getLocale

          Locale getLocale()

      Returns the locale specified for this response using the `setLocale(java.util.Locale)` method. Calls made to `setLocale` after the response is committed have no effect. If no locale has been specified, the container's default locale is returned.
      See Also:
        `setLocale(java.util.Locale)`

Copyright © 1996-2013, Oracle and/or its affiliates. All Rights Reserved. Use is subject to license terms.